#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <unistd.h>
#include <termios.h>

#include <sys/socket.h>
#include <sys/un.h>
#include <sys/stat.h>

#include "serial.h"

#define SOCKET_FILE	"/tmp/UDSDGSRV"


#define SERIALDEV	"/dev/ttyUSB0"
#define BAUDRATE	B115200 
//#define BAUDRATE	B9600

#define BUFFER_SIZE		20



unsigned char buffer[BUFFER_SIZE];
int nb_read;


void ipc_function(void)
{
	int socket_fd;
	struct sockaddr_un server_address;
	struct sockaddr_un client_address;
	int bytes_received, bytes_sent;

	int integer_buffer;
	socklen_t address_length;

	address_length = sizeof(struct sockaddr_un);

	if((socket_fd = socket(PF_UNIX, SOCK_DGRAM, 0)) < 0)
	{
		perror("server: socket");
		exit(1);
	}

	memset(&server_address, 0, sizeof(server_address));
	server_address.sun_family = AF_UNIX;
	strcpy(server_address.sun_path, SOCKET_FILE);

	unlink(SOCKET_FILE);
	if(bind(socket_fd, (const struct sockaddr *) &server_address, sizeof(server_address)) < 0)
	{
		close(socket_fd);
		perror("server: bind");
		exit(2);
	}
	chmod(SOCKET_FILE, 00777);

	while(1)
	{
		bytes_received = recvfrom(socket_fd, (char *) &integer_buffer, sizeof(int), 0, (struct sockaddr *) &(client_address), &address_length);
		printf("bytes_received :%d:\n", bytes_received);
		printf("received value :%x:\n", integer_buffer);

		integer_buffer = 65;
		bytes_sent = sendto(socket_fd, (char *)&integer_buffer, sizeof(int), 0, (struct sockaddr *) &(client_address), address_length);
	}

}


int main(void)
{
	int serial_fd, i, j;
	
	//for debug
	//char * car;
	//scanf(car);

	serial_fd = ouvertureSerie(SERIALDEV, BAUDRATE);
	if(serial_fd<0)
	{
		fprintf(stderr, "Erreur ouverture port série.\n");
		exit(-1);
	}

	printf("Port série initialisé\n");
	fflush(stdout);

	while(1)
	{
		/*
		nb_read = read(serial_fd, buffer, BUFFER_SIZE);
		printf("XX:");
		for(i=0; i<nb_read; i++)
			printf(":%02x",buffer[i]);
		printf(":XX\n");
		fflush(stdout);
		*/
		//printf("Lecture\n");

		nb_read = read(serial_fd, buffer, 1);

		if(nb_read)
		{
			printf("%02x\t", buffer[0]);
			j=buffer[0];
			for(i=0; i<j; i++)
			{
				nb_read = read(serial_fd, buffer, 1);
				if (i==3)
					printf("%02x\t", buffer[0]);
				else
					printf("%02x\t", buffer[0]);
			}
			printf("\n");
			fflush(stdout);
		}
	}

	return 0;
}
