#include <msp430.h>
#include <stdint.h>

//#include "serial.h"
#include "RF_Connection.h"
#include "RF1A.h"
#include "transmitter_conf.h"


#define BUFFER_SIZE		5	// maximum size of data sent by rf

#define SLIP_END			0xC0
#define SLIP_ESC			0xDB
#define SLIP_ESC_END		0xDC
#define SLIP_ESC_ESC		0xDD

#define PWM_PERIOD		255

//enum slip_state_e{slip_in, slip_escaped};
//volatile static enum slip_state_e slip_state;

/*
#ifndef TRANSMITTER_ID
#define TRANSMITTER_ID		4
#endif

#ifndef DELAY
#define DELAY	1500000 // 500 ms
#endif
*/

volatile uint8_t buffer[BUFFER_SIZE];
volatile uint8_t temp[NB_BANGLES][2];
volatile uint8_t fin[NB_BANGLES][NB_BANGLES-1];

void packet_received(void)
{
}

// Any other commands are for RSSI measurement
void send_cmd(unsigned char command, uint8_t channel)
{
	buffer[0] = 3;
	buffer[1] = TRANSMITTER_ID;
	buffer[2] = command;
	buffer[3] = channel;
	//P1OUT ^= 0x01;
//	buffer[0] = ptr_buf-1;
	rf_transmit(buffer, 4);
	//P1OUT ^= 0x01;
}

void port_mapping(void)
{
  PMAPPWD = 0x02D52;            // Get write-access to port mapping regs  
  P3MAP0 = PM_TA1CCR1A;       	// Map TA1CCR1 output to P3.0 
  P3MAP1 = PM_TA1CCR2A;         // Map TA1CCR2 output to P3.1 
  P3MAP2 = PM_TA0CCR1A;         // Map TA0CCR1 output to P3.2 
  P3MAP3 = PM_TA0CCR2A;         // Map TA0CCR2 output to P3.3  
  P3MAP4 = PM_TA0CCR3A;         // Map TA0CCR3 output to P3.4 
  P3MAP5 = PM_TA0CCR4A;         // Map TA0CCR4 output to P3.5 
  PMAPPWD = 0;                  // Lock port mapping registers 
  
  P3DIR |= 0x3F;          		// P3.0 to P3.5 as output
  P3SEL |= 0x3F;     		    // P3.0 and P3.3 options select
}



void led_init(void)
{
	P1OUT &= ~BIT0;
	P1DIR |= BIT0;
}

void stop_led(void)
{
	
	// Stop the PWM
	TA0CCR0 = 0;
	TA1CCR0 = 0;

  	TA1CCTL1 = OUTMOD_0;                      // CCR1 reset/set
  	TA1CCTL2 = OUTMOD_0;                      // CCR2 reset/set
  	TA0CCTL1 = OUTMOD_0;                      // CCR1 reset/set
  	TA0CCTL2 = OUTMOD_0;                      // CCR2 reset/set
  	TA0CCTL3 = OUTMOD_0;                      // CCR3 reset/set
  	TA0CCTL4 = OUTMOD_0;                      // CCR4 reset/set

	P3OUT &= ~(0x3F);
}


void set_color(uint8_t red, uint8_t blue, uint8_t green)
{
   	
	// 1- Configure the PWM PERIOD
	//    Same period for the two timers
	TA0CCR0 = PWM_PERIOD;
	TA1CCR0 = PWM_PERIOD;

	// 2- Set the ratio for the output
	//    0xFF = 100%, 0x00 = 0%
	//  Red
	TA1CCR1 = (red*PWM_PERIOD)/0xFF;
	TA0CCR2 = (red*PWM_PERIOD)/0xFF;
	// Blue
	TA0CCR1 = (blue*PWM_PERIOD)/0xFF;
	TA0CCR4 = (blue*PWM_PERIOD)/0xFF;
	// Green
	TA1CCR2 = (green*PWM_PERIOD)/0xFF;
	TA0CCR3 = (green*PWM_PERIOD)/0xFF;
	
  	TA1CCTL1 = OUTMOD_7;                      // CCR1 reset/set
  	TA1CCTL2 = OUTMOD_7;                      // CCR2 reset/set
  	TA0CCTL1 = OUTMOD_7;                      // CCR1 reset/set
  	TA0CCTL2 = OUTMOD_7;                      // CCR2 reset/set
  	TA0CCTL3 = OUTMOD_7;                      // CCR3 reset/set
  	TA0CCTL4 = OUTMOD_7;                      // CCR4 reset/set

	// Activate PWM
	TA0CTL = TASSEL_1 + MC_1 + TACLR;         // ACLK, up mode, clear TAR
	TA1CTL = TASSEL_1 + MC_1 + TACLR;         // ACLK, up mode, clear TAR
	

//	P3OUT = 0x01;
}


int main(void)
{
	WDTCTL = WDTPW + WDTHOLD;                 // Stop WDT



	led_init();
//	uart_init();
//	slip_state = slip_in;
	port_mapping();
	rf_init();
	ReceiveOff();

	//for debug
	int i;
	//__delay_cycles(3000000);
	owndelay(30);
	
	for(i=0; i < 5; i++){
		set_color(0xFF, 0x00, 0x00);
		__delay_cycles(100000);
		set_color(0x00, 0x00, 0x00);
		__delay_cycles(100000);
	}
	//__delay_cycles(9000000);
	owndelay(90);

	// enable interrupt
	_BIS_SR(GIE);	

	//ChangeChannel(CHANNEL_START);
	//ReceiveOff();

	while(1)
	{
//		P1OUT = 0x01;
		uint16_t i;
		for(i = CHANNEL_START; i <= CHANNEL_STOP ; i += CHANNEL_STEP){ //defined in RF1A.h
			
			//for debug
			set_color(0xFF, 0x00, 0x00);
			__delay_cycles(50000);
			set_color(0x00, 0x00, 0x00);
			
			ChangeChannel(i);			//Set channel
			ReceiveOff();
			//__delay_cycles(1000000);	//Let the receiver to change freqency
			owndelay(10);

			//for(j=CHANNEL_START; j<CHANNEL_STOP; j++){
				//send_cmd('a', i);			//10 dummy commands to assess RSSI
				//__delay_cycles(DELAY);
				//set_color(0x00, 0x00, 0xFF);
				//__delay_cycles(10000);
				//set_color(0xFF, 0x00, 0xFF);
			//}
			
			send_cmd('f', i+CHANNEL_STEP);				//Advertise receiver to change channel
			//send_cmd(i, i+CHANNEL_STEP);
			__delay_cycles(DELAY);
			
		}

		//For debug, end of frame
		for(i=0; i < 5; i++){
			set_color(0xFF, 0x00, 0x00);
			 __delay_cycles(100000);
			set_color(0x00, 0x00, 0x00);
			__delay_cycles(100000);
		}

		while(1){}
	}
	return 0;
}

